/* $Id: debug.h,v 1.7 2002/04/24 11:31:41 jym Exp $ */

#ifndef _DEBUG_H_
#define _DEBUG_H_

extern uint verbose;

#ifdef DBG
#define DEBUG(X) printf("In %s from %s:%i: %s\n", __FUNCTION__, __FILE__, __LINE__, X)
#else
#define DEBUG(X)
#endif


#ifdef DBG_ENTER
#define DENTER printf("Call %s in %s:%i\n", __FUNCTION__, __FILE__, __LINE__)
#else
#define DENTER
#endif

#ifdef DBG_LEAVE
#define DLEAVE printf("Leave %s in %s:%i\n", __FUNCTION__, __FILE__, __LINE__)
#else
#define DLEAVE
#endif

#define DEBUG_MEM (verbose & 0x1)
#define DEBUG_CPU (verbose & 0x2)
#define DEBUG_COMPIL (verbose & 0x4)
#define DEBUG_VIDEO (verbose & 0x8)
#define DEBUG_KBD (verbose & 0x10)
#define DEBUG_LOAD (verbose & 0x20)
#define DEBUG_TIMER (verbose & 0x40)
#define DEBUG_INT (verbose & 0x80)
#define DEBUG_SENSOR (verbose & 0x100)

#endif
