/* $Id: kbd.c,v 1.12 2002/05/14 15:51:25 jym Exp $
 *
 * Gestion clavier
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "misc.h"
#include "spec.h"
#include "c18.h"
#include "memory.h"
#include "ansi.h"
#include "debug.h"

#ifdef HAVE_SDL
#include <SDL.h>
#include <SDL_thread.h>

SDL_Thread *thread_id = NULL;
#endif

extern int stat_kbd;

#define KEY(X) (1 << X)

int key_state1;
int key_state2;


#ifdef HAVE_SDL
static void kbd_down_key(SDLKey sym)
{
	/*
	if(DEBUG_KBD)
		printf("Touche %s pressee\n", SDL_GetKeyName(sym));
		*/

	switch(sym) {
		case SDLK_PAGEUP: /* touche cote up */
			key_state1 = (key_state1 & ~KEY(0)) + KEY(0);
			break;
		case SDLK_PAGEDOWN: /* touche cote down */
			key_state1 = (key_state1 & ~KEY(1)) + KEY(1);
			break;
		case SDLK_UP: /* fonction 1 */
			key_state1 = (key_state1 & ~KEY(2)) + KEY(2);
			break;
		case SDLK_DOWN: /* fonction 2 */
			key_state1 = (key_state1 & ~KEY(3)) + KEY(3);
			break;
		case SDLK_LEFT: /* fonction 3 */
			key_state1 = (key_state1 & ~KEY(4)) + KEY(4);
			break;
		case SDLK_RIGHT: /* fonction 4 */
			key_state1 = (key_state1 & ~KEY(5)) + KEY(5);
			break;
		case SDLK_KP0:
			key_state1 = (key_state1 & ~KEY(6)) + KEY(6);
			break;
		case SDLK_KP1:
			key_state1 = (key_state1 & ~KEY(7)) + KEY(7);
			break;
		case SDLK_KP2:
			key_state1 = (key_state1 & ~KEY(8)) + KEY(8);
			break;
		case SDLK_KP3:
			key_state1 = (key_state1 & ~KEY(9)) + KEY(9);
			break;
		case SDLK_KP4:
			key_state1 = (key_state1 & ~KEY(10)) + KEY(10);
			break;
		case SDLK_KP5:
			key_state1 = (key_state1 & ~KEY(11)) + KEY(11);
			break;
		case SDLK_KP6:
			key_state1 = (key_state1 & ~KEY(12)) + KEY(12);
			break;
		case SDLK_KP7:
			key_state1 = (key_state1 & ~KEY(13)) + KEY(13);
			break;
		case SDLK_KP8:
			key_state1 = (key_state1 & ~KEY(14)) + KEY(14);
			break;
		case SDLK_KP9:
			key_state1 = (key_state1 & ~KEY(15)) + KEY(15);
			break;
		case SDLK_KP_PERIOD: /* l'enregistrement (cote) */
			key_state1 = (key_state1 & ~KEY(16)) + KEY(16);
			break;
		case SDLK_KP_DIVIDE: /* le diese */
			key_state1 = (key_state1 & ~KEY(17)) + KEY(17);
			break;
		case SDLK_KP_MULTIPLY: /* l'etoile */
			key_state2 = (key_state2 & ~KEY(0)) + KEY(0);
			break;
		case SDLK_KP_MINUS: /* l'agenda */
			key_state2 = (key_state2 & ~KEY(1)) + KEY(1);
			break;
		case SDLK_KP_PLUS: /* la touche rouge */
			key_state2 = (key_state2 & ~KEY(2)) + KEY(2);
			break;
		case SDLK_KP_ENTER: /* la touche verte */
			key_state2 = (key_state2 & ~KEY(3)) + KEY(3);
			break;
		default:
	}

	/*
	if(DEBUG_KBD)
		printf("key_state:\t0x%05X\t0x%05X\n", key_state1, key_state2);
		*/
}


static void kbd_up_key(SDLKey sym)
{
	/*
	if(DEBUG_KBD)
		printf("Touche %s relachee\n", SDL_GetKeyName(sym));
		*/

	switch(sym) {
		case SDLK_PAGEUP: /* touche cote up */
			key_state1 = (key_state1 & ~KEY(0));
			break;
		case SDLK_PAGEDOWN: /* touche cote down */
			key_state1 = (key_state1 & ~KEY(1));
			break;
		case SDLK_UP: /* fonction 1 */
			key_state1 = (key_state1 & ~KEY(2));
			break;
		case SDLK_DOWN: /* fonction 2 */
			key_state1 = (key_state1 & ~KEY(3));
			break;
		case SDLK_LEFT: /* fonction 3 */
			key_state1 = (key_state1 & ~KEY(4));
			break;
		case SDLK_RIGHT: /* fonction 4 */
			key_state1 = (key_state1 & ~KEY(5));
			break;
		case SDLK_KP0:
			key_state1 = (key_state1 & ~KEY(6));
			break;
		case SDLK_KP1:
			key_state1 = (key_state1 & ~KEY(7));
			break;
		case SDLK_KP2:
			key_state1 = (key_state1 & ~KEY(8));
			break;
		case SDLK_KP3:
			key_state1 = (key_state1 & ~KEY(9));
			break;
		case SDLK_KP4:
			key_state1 = (key_state1 & ~KEY(10));
			break;
		case SDLK_KP5:
			key_state1 = (key_state1 & ~KEY(11));
			break;
		case SDLK_KP6:
			key_state1 = (key_state1 & ~KEY(12));
			break;
		case SDLK_KP7:
			key_state1 = (key_state1 & ~KEY(13));
			break;
		case SDLK_KP8:
			key_state1 = (key_state1 & ~KEY(14));
			break;
		case SDLK_KP9:
			key_state1 = (key_state1 & ~KEY(15));
			break;
		case SDLK_KP_PERIOD: /* l'enregistrement (cote) */
			key_state1 = (key_state1 & ~KEY(16));
			break;
		case SDLK_KP_DIVIDE: /* le diese */
			key_state1 = (key_state1 & ~KEY(17));
			break;
		case SDLK_KP_MULTIPLY: /* l'etoile */
			key_state2 = (key_state2 & ~KEY(0));
			break;
		case SDLK_KP_MINUS: /* l'agenda */
			key_state2 = (key_state2 & ~KEY(1));
			break;
		case SDLK_KP_PLUS: /* la touche rouge */
			key_state2 = (key_state2 & ~KEY(2));
			break;
		case SDLK_KP_ENTER: /* la touche verte */
			key_state2 = (key_state2 & ~KEY(3));
			break;
		default:
	}
	
	/*
	if(DEBUG_KBD)
		printf("key_state:\t0x%05X\t0x%05X\n", key_state1, key_state2);
		*/
}







static int kbd(void *data)
{
	SDL_Event event;

	while ( SDL_WaitEvent(&event) ) {
		switch (event.type) {
		case SDL_KEYDOWN:
			kbd_down_key(event.key.keysym.sym);
			cpu_interrupt(INTERRUPT(C_IKBD));
			break;
		case SDL_KEYUP:
			kbd_up_key(event.key.keysym.sym);
			cpu_interrupt(INTERRUPT(C_IKBD));
			break;
		case SDL_QUIT:
			quit(0);
		}

	}

	return 0;
}


/* initialisation via SDL
 */
int kbd_init(void)
{
	//puts("Keyboard (22 touches)"PRINT_OK);
	thread_id = SDL_CreateThread(kbd, NULL);

	return 0;
}

int kbd_close(void)
{
	SDL_KillThread(thread_id);
	return 0;
}

#else /* !HAVE_SDL */

/* Initialisation sans SDL
 */
int kbd_init(void)
{
	/* utiliser cfmakeraw() */
	//puts("Keyboard (22 touches)"PRINT_FAILED);
	return 0;
}
int kbd_close(void)
{
	return 0;
}


#endif



/* Pour recuperer l'etat du clavier
 */
int kbd_get(int where)
{
	int rv = 0;

	if(where)
		rv = key_state2;
	else
		rv = key_state1;

	stat_kbd++;
	return rv;
}



/* Pour changer l'etat du clavier (lock/unlock seront gere ici)
 */
int kbd_set(int where)
{
	//puts("kbd_set(): Fonction not implemented");
	return 0;
}
