/* $Id: misc.c,v 1.13 2002/06/09 14:36:35 jym Exp $
 *
 * Divers
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <unistd.h>
#include <termios.h>
#include <curses.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/resource.h>
#include "video.h"
#include "memory.h"
#include "file.h"
#include "spec.h"
#include "system.h"
#include "kbd.h"


#ifdef TOTO
char *strlcpy(char *dst, char *src, size_t s)
{
	return strncpy(dst, src, s);
}
#endif

/* tester si c'est un chiffre decimal
 */
int ischiffre(char *s)
{
	int i = 0;

	if(s == NULL) {
		return 0;
	}

	while(s[i] != 0 && s[i] != '\n') {
		if(!isdigit(s[i])) {
			return 0;
		}
		i++;
	}

	return 42;
}


/* tester si c'est un chiffre hexa
 */
int ishexa(char *s)
{
	int i = 0;

	if(s == NULL) {
		return 0;
	}

	while(s[i] != 0 && s[i] != '\n') {
		if(!isxdigit(s[i]) && (s[i] != 'x') && (s[i] != 'X')) {
			return 0;
		}
		i++;
	}

	return 42;
}


/* compare deux chaines
 */
int cmp(char *word, char *code)
{
	int length = 0;

	length = strlen(code);

	if(length < strlen(word)) {
		length = strlen(word);
	}

	if(length) {
		if(!strncasecmp(code, word, length)) {
			return 42;
		}
	}

	return 0;
}


/* Ctrl-C pour quitter
 */
void quit(int s)
{
	file_close();
	mem_free();
	kbd_close();
	fb_close();
	endwin();
	puts("");
	exit(0);
}


/* Renvoie le nombre de secondes a partir d'une struct rusage
 */
double my_time(struct rusage *ru)
{
	return (((double)ru->ru_utime.tv_sec + (double)ru->ru_stime.tv_sec) + (((double)ru->ru_utime.tv_usec + (double)ru->ru_stime.tv_usec)/1000000.0));
}




/* Compare deux temps
 */
double end_clock(struct rusage *old)
{
	struct rusage tmp;

	if(getrusage(RUSAGE_SELF, &tmp)) perror("getrusage");

	return (double)(my_time(&tmp) - my_time(old));
}


/* Appel de getrusage pour le temps a un instant donne
 */
struct rusage *start_clock(void)
{
	struct rusage *rv = malloc(sizeof(struct rusage));

	if(getrusage(RUSAGE_SELF, rv)) perror("getrusage");

	return rv;
}


/* wrapper pour malloc
 */
void *jalloc(size_t size)
{
	void *mem = malloc(size);

	if(!mem) {
		perror("alloc");
		quit(0);
	}

	bzero(mem, size);

	return mem;
}
