/* $Id: spec.h,v 1.13 2002/05/10 16:36:00 jym Exp $ */

#ifndef _SPEC_H_
#define _SPEC_H_

/* memoire externe doit etre: 512k word (1 word == 18 bits)
 *
 * 0x00000 => 0x000E9	: internal memory (ROM + RAM)
 * 0x000F0 : timer
 * 0x000F1 : keyboard
 * 0x000F2 : keyboard
 * 0x000F3 : audio ctrl
 * 0x000F4 : audio data
 * 0x000F5 : video ram addr
 * 0x000F6 : video ram data
 * 0x000F7 : radio ctrl
 * 0x000F8 : radio cmd
 * 0x000F9 : radio data
 * 0x000FA : RAM addr
 * 0x000FB : RAM data
 * 0x000FC :
 * 0x000FD :
 * 0x000FE : sensor (temporaire)
 * 0x000FF : control register
 *
 * Audio Video Radio serial keyboard apm sensor gps timer 
 *
 * Ces trois la sont des donnes (read-only) en memoire externe
 * APM: un registre voltage
 * SENSORS: un registre temp (cpu + antenne) (9 bits suffisant ?) Et temp externe ?
 * GPS: ?? integre a radio ??
 *
 * VIDEO: avec 2^18 => 624x420 16bits. 2 registre (adresse, data) si data==0, donne adr et sys renvoie data. Si data!=0 donne adr et sys mets data a adr.
 * RAM: 2. Comme ram video.
 * AUDIO:
 * RADIO:
 * KEYBOARD: 2 registre pour 36 touches.
 * TIMER: un registre.
 *
 *
 * Control register:
 * 17................0
 *   p           iiiii
 *		 stkar
 *
 * p = page
 *
 * i = interrupt
 * ----1 = radio
 * ---1- = audio
 * --1-- = kbd
 * -1--- = timer (ou video ?)
 * 1---- = serial
 *
 *
 */

#define IRAM_START 0x0
#define IRAM_END 0xBF
#define RAM_START 0x0
#define RAM_END 0x7FFFF


#define REG_TIMER 0xB0
#define REG_KBD 0xB1
#define REG_AUCTRL 0xB3
#define REG_AUDATA 0xB4
#define REG_VIDADDR 0xB5
#define REG_VIDDATA 0xB6
#define REG_RFCTRL 0xB7
#define REG_RFCMD 0xB8
#define REG_RFDATA 0xB9
#define REG_RAMADDR 0xBA
#define REG_RAMDATA 0xBB
#define REG_SENSOR 0xBE
#define REG_CTRL 0xBF
#define C_IRADIO 0
#define C_IAUDIO 1
#define C_IKBD 2
#define C_ITIMER 3
#define C_ISERIAL 4
#define INTERRUPT(X) (1 << X)
#define C(X) ((mem_get(REG_CTRL) >> X) & 1)


#define DEFAULT_LOAD 0x00
#define DEFAULT_IP DEFAULT_LOAD
#define STDIN 0
#define STDOUT 1
#define STDERR 2


#endif
