/* $Id: system.c,v 1.10 2002/06/09 14:36:35 jym Exp $
 *
 * Gestion systeme: timer, senseurs, gps, ...etc.
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>
#include "memory.h"
#include "spec.h"
#include "c18.h"
#include "debug.h"
#include "ansi.h"
#ifdef HAVE_SDL
#include <SDL.h>

static SDL_TimerID timer;
#endif

extern int stat_timer;
extern int stat_gps;
static int t = 0;

#ifdef HAVE_SDL
Uint32 timer_update(Uint32 interval, void *para)
{
	t = (t++) & 0x3FFFF;

	cpu_interrupt(INTERRUPT(C_ITIMER));

	return interval;
}


int timer_init(void)
{
	timer = SDL_AddTimer(1, timer_update, NULL);
	return 0;
}



int timer_stop(void)
{
	SDL_RemoveTimer(timer);
	return 0;
}

#else

void timer_update(int s)
{
	t = (t++) & 0x3FFFF;
	cpu_interrupt(INTERRUPT(C_ITIMER));
}

int timer_init(void)
{
	struct itimerval tv;

	tv.it_interval.tv_sec = 0;
	tv.it_interval.tv_usec = 10;
	tv.it_value.tv_sec = 0;
	tv.it_value.tv_usec = 10;
	signal(SIGALRM, timer_update);
	setitimer(ITIMER_REAL, &tv, NULL); /* pkoi pas VIRTUAL ? */
	return 0;
}


int timer_stop(void)
{
	struct itimerval tv;

	tv.it_interval.tv_sec = 0;
	tv.it_interval.tv_usec = 0;
	tv.it_value.tv_sec = 0;
	tv.it_value.tv_usec = 0;
	setitimer(ITIMER_REAL, &tv, NULL);
	signal(SIGALRM, SIG_DFL);
	return 0;
}

#endif


int timer_get(void)
{
	stat_timer++;
	/*
	if(DEBUG_TIMER)
		printf("get timer: %i\n", t);
		*/
	return t;
}



/* About GPS
 */
int gps_init(void)
{
	return 0;
}


int gps_get(void)
{
	stat_gps++;
	return 0;
}


